ospipsv: xospipsv_flash_polled_example.c File Reference

| ospipsv Xilinx SDK Drivers API Documentation

- Overview
- Data Structures
- APIs
- File List
- Examples

Functions
xospipsv_flash_polled_example.c File Reference

## Overview

This file contains a design example using the OSPIPSV driver (xospipsv) The example writes to flash in IO mode and reads it back in DMA mode.

It runs in polled mode. The hardware which this example runs on, must have an octal serial Flash (Micron) for it to run.

This example has been tested with the Micron Octal Serial Flash (mt35xu01gbba).

Note

None.

     MODIFICATION HISTORY:

     Ver   Who Date     Changes

     1.0   nsk  02/19/17 First release
           sk   01/09/19 Updated flash configuration table with
                         supported commands.
           sk   02/04/19 Add support for SDR+PHY and DDR+PHY modes.
     1.0   akm 03/29/19 Fixed data alignment issues on IAR compiler.
     1.1   sk  07/23/19 Based on RX Tuning, updated the dummy cycles.
           sk  08/08/19 Issue device reset to bring back to default state.

## Functions
int | OspiPsvPolledFlashExample (XOspiPsv *OspiPsvInstancePtr, u16 OspiPsvDeviceId)
| The purpose of this function is to illustrate how to use the XOspiPsv device driver using OSPI flash devices greater than or equal to 128Mb. More...
int | FlashReadID (XOspiPsv *OspiPsvPtr)
| Reads the flash ID and identifies the flash in FCT table. More...
int | FlashErase (XOspiPsv *OspiPsvPtr, u32 Address, u32 ByteCount, u8 *WriteBfrPtr)
| This function erases the sectors in the serial Flash connected to the OSPIPSV interface. More...
int | FlashIoWrite (XOspiPsv *OspiPsvPtr, u32 Address, u32 ByteCount, u8 *WriteBfrPtr)
| This function writes to the serial Flash connected to the OSPIPSV interface. More...
int | FlashLinearWrite (XOspiPsv *OspiPsvPtr, u32 Address, u32 ByteCount, u8 *WriteBfrPtr)
| This function writes to the serial Flash connected to the OSPIPSV interface. More...
int | FlashRead (XOspiPsv *OspiPsvPtr, u32 Address, u32 ByteCount, u8 *WriteBfrPtr, u8 *ReadBfrPtr)
| This function performs read. More...
int | BulkErase (XOspiPsv *OspiPsvPtr, u8 *WriteBfrPtr)
| This functions performs a bulk erase operation when the flash device has a single die. More...
int | DieErase (XOspiPsv *OspiPsvPtr, u8 *WriteBfrPtr)
| This functions performs a die erase operation on all the die in the flash device. More...
int | FlashEnterExit4BAddMode (XOspiPsv *OspiPsvPtr, int Enable)
| This API enters the flash device into 4 bytes addressing mode. More...
int | FlashSetSDRDDRMode (XOspiPsv *OspiPsvPtr, int Mode)
| This API enters the flash device into Octal DDR mode or exit from octal DDR mode (switches to Extended SPI mode). More...
int | main (void)
| Main function to call the OSPIPSV Flash Polled example. More...
u32 | XOspiPsv_Get_Proto (XOspiPsv *OspiPsvInstancePtr, int Read)
| The purpose of this function is to determine the number of lines used for command, address and data. More...

## Function Documentation

int BulkErase | ( | XOspiPsv * | OspiPsvPtr,
|  | u8 * | WriteBfrPtr
| ) |  |

This functions performs a bulk erase operation when the flash device has a single die.

Works for both Spansion and Micron

Parameters

  OspiPsvPtr | is a pointer to the OSPIPSV driver component to use.
  WritBfrPtr | is the pointer to command+address to be sent

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

int DieErase | ( | XOspiPsv * | OspiPsvPtr,
|  | u8 * | WriteBfrPtr
| ) |  |

This functions performs a die erase operation on all the die in the flash device.

This function uses the die erase command for Micron 512Mbit and 1Gbit

Parameters

  OspiPsvPtr | is a pointer to the OSPIPSV driver component to use.
  WritBfrPtr | is the pointer to command+address to be sent

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

int FlashEnterExit4BAddMode | ( | XOspiPsv * | OspiPsvPtr,
|  | int | Enable
| ) |  |

This API enters the flash device into 4 bytes addressing mode.

As per the Micron spec, before issuing the command to enter into 4 byte addr mode, a write enable command is issued.

Parameters

  OspiPtr | is a pointer to the OSPIPSV driver component to use.
  Enable | is a either 1 or 0 if 1 then enters 4 byte if 0 exits.

Returns
  - XST_SUCCESS if successful.
  - XST_FAILURE if it fails.

int FlashErase | ( | XOspiPsv * | OspiPsvPtr,
|  | u32 | Address,
|  | u32 | ByteCount,
|  | u8 * | WriteBfrPtr
| ) |  |

This function erases the sectors in the serial Flash connected to the OSPIPSV interface.

Parameters

  OspiPsvPtr | is a pointer to the OSPIPSV driver component to use.
  Address | contains the address of the first sector which needs to be erased.
  ByteCount | contains the total size to be erased.
  Pointer | to the write buffer (which is to be transmitted)

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

int FlashIoWrite | ( | XOspiPsv * | OspiPsvPtr,
|  | u32 | Address,
|  | u32 | ByteCount,
|  | u8 * | WriteBfrPtr
| ) |  |

This function writes to the serial Flash connected to the OSPIPSV interface.

All the data put into the buffer must be in the same page of the device with page boundaries being on 256 byte boundaries. This can be used in IO or DMA mode.

Parameters

  OspiPsvPtr | is a pointer to the OSPIPSV driver component to use.
  Address | contains the address to write data to in the Flash.
  ByteCount | contains the number of bytes to write.
  Pointer | to the write buffer (which is to be transmitted)

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

int FlashLinearWrite | ( | XOspiPsv * | OspiPsvPtr,
|  | u32 | Address,
|  | u32 | ByteCount,
|  | u8 * | WriteBfrPtr
| ) |  |

This function writes to the serial Flash connected to the OSPIPSV interface.

All the data put into the buffer must be in the same page of the device with page boundaries being on 256 byte boundaries. This can be used when controller is in Linear mode.

Parameters

  OspiPsvPtr | is a pointer to the OSPIPSV driver component to use.
  Address | contains the address to write data to in the Flash.
  ByteCount | contains the number of bytes to write.
  Pointer | to the write buffer (which is to be transmitted)

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

References XOspiPsv_Msg::Addr, XOspiPsv_Msg::Addrsize, XOspiPsv_Msg::Addrvalid, XOspiPsv_Msg::ByteCount, XOspiPsv_Msg::Dummy, XOspiPsv_Msg::Flags, XOspiPsv_Msg::IsDDROpCode, XOspiPsv_Msg::Opcode, XOspiPsv_Msg::Proto, XOspiPsv_Msg::RxBfrPtr, XOspiPsv::SdrDdrMode, XOspiPsv_Msg::TxBfrPtr, XOspiPsv_Get_Proto(), and XOspiPsv_PollTransfer().

Referenced by OspiPsvPolledFlashExample().

int FlashRead | ( | XOspiPsv * | OspiPsvPtr,
|  | u32 | Address,
|  | u32 | ByteCount,
|  | u8 * | WriteBfrPtr,
|  | u8 * | ReadBfrPtr
| ) |  |

This function performs read.

DMA is the default setting.

Parameters

  OspiPsvPtr | is a pointer to the OSPIPSV driver component to use.
  Address | contains the address of the first sector which needs to be erased.
  ByteCount | contains the total size to be erased.
  Pointer | to the write buffer which contains data to be transmitted
  Pointer | to the read buffer to which valid received data should be written

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

int FlashReadID | ( | XOspiPsv * | OspiPsvPtr | ) |

Reads the flash ID and identifies the flash in FCT table.

Parameters

  None. |

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

int FlashSetSDRDDRMode | ( | XOspiPsv * | OspiPsvPtr,
|  | int | Mode
| ) |  |

This API enters the flash device into Octal DDR mode or exit from octal DDR mode (switches to Extended SPI mode).

Parameters

  OspiPtr | is a pointer to the OSPIPSV driver component to use.
  Enable | is either 1 or 0 if 1 then enter octal DDR mode if 0 exits.

Returns
  - XST_SUCCESS if successful.
  - XST_FAILURE if it fails.

int main | ( | void |  | ) |

Main function to call the OSPIPSV Flash Polled example.

Parameters

  None |

Returns
  XST_SUCCESS if successful, otherwise XST_FAILURE.

Note
  None

References OspiPsvPolledFlashExample().

int OspiPsvPolledFlashExample | ( | XOspiPsv * | OspiPsvInstancePtr,
|  | u16 | OspiPsvDeviceId
| ) |  |

The purpose of this function is to illustrate how to use the XOspiPsv device driver using OSPI flash devices greater than or equal to 128Mb.

This function reads data in either DMA or DAC mode.

Parameters

  None. |

Returns
  XST_SUCCESS if successful, else XST_FAILURE.

Note
  None.

References FlashEnterExit4BAddMode(), FlashErase(), FlashIoWrite(), FlashLinearWrite(), FlashRead(), FlashReadID(), FlashSetSDRDDRMode(), XOspiPsv_CfgInitialize(), XOspiPsv_DeviceReset(), XOspiPsv_GetOptions(), XOspiPsv_LookupConfig(), XOspiPsv_SelectFlash(), XOspiPsv_SetClkPrescaler(), and XOspiPsv_SetOptions().

Referenced by main().

u32 XOspiPsv_Get_Proto | ( | XOspiPsv * | OspiPsvInstancePtr,
|  | int | Read
| ) |  |

The purpose of this function is to determine the number of lines used for command, address and data.

Parameters

  OspiPsvPtr | is a pointer to the OSPIPSV driver component to use.
  Read | is to tell whether a read or write

Returns
  returns value to program the lines for command, address and data.

Note
  None.

References XOspiPsv::OpMode.